package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLVertices_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLVertices extends JNIObject  {
	
	/* @generated */
	protected ISLVertices(long ptr) {
		/*** PROTECTED REGION ID(ISLVertices_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLVertices build(long ptr) {
		return new ISLVertices(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLVertices_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_vertices_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_vertices_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_vertices_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_vertices_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_vertices_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_vertices_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_vertices_get_n_vertices 
	 * 
	 * @generated
	**/
	public int getNbVertices() {
		/*** PROTECTED REGION ID(isl_vertices_get_n_vertices) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_vertices_get_n_vertices(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_vertices_numberof_vertex 
	 * 
	 * @generated
	**/
	public int getNbVertex() {
		/*** PROTECTED REGION ID(isl_vertices_numberof_vertex) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_vertices_numberof_vertex(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_vertices_get_vertex_at 
	 * 
	 * @generated
	**/
	public ISLVertex getVertexAt(int pos) {
		/*** PROTECTED REGION ID(isl_vertices_get_vertex_at) DISABLED START ***/
		ISLVertex res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLVertex.build(ISLNative.isl_vertices_get_vertex_at(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_vertices_numberof_cell 
	 * 
	 * @generated
	**/
	public int getNbCell() {
		/*** PROTECTED REGION ID(isl_vertices_numberof_cell) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_vertices_numberof_cell(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_vertices_get_cell_at 
	 * 
	 * @generated
	**/
	public ISLCell getCellAt(int pos) {
		/*** PROTECTED REGION ID(isl_vertices_get_cell_at) DISABLED START ***/
		ISLCell res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLCell.build(ISLNative.isl_vertices_get_cell_at(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLVertices_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
